
var
  serial4key: string;

// Conversion STRING -> INTEGER
function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;

// Conversion HEX -> ASCII
function HexToAscii(Hex: string): string;
begin
  result := chr(StrToInt('$' + hex));
end;

// Conversion INTEGER -> STRING HEXA
function IntToHex(number: cardinal; digits: byte; Letter_Case: byte): string;
var
  a: cardinal;
  r: byte;
  temp: string;
const
  hUpper = '0123456789ABCDEF';
  hLower = '0123456789abcdef';
begin
  temp := '';
  a := number;
  while a <> 0 do begin
    r := a mod 16;
    a := a div 16;
    if Letter_Case = 0 then temp := temp + hUpper[r + 1]
    else temp := temp + hLower[r + 1];
  end;

  result := '';
  for r := length(temp) downto 1 do
    result := result + temp[r];

  if digits > length(result) then
    for r := length(result) to digits - 1 do
      insert('0', result, 1);
end;

function rol5(i: integer): integer; assembler;
asm
  rol al, 5
end;

// Procedure qui ecrit le serial4key dans le keyfile
procedure MakeKey;
var
  F: Text;
  N: string;
  buffer1, buffer2: array[0..255] of char;
  a1, a2: integer;
  Lpbi: TbrowseInfo;
  PidlStart: PItemIDList;
  Malloc: IMalloc;
  edit1, edit2, sselected: string;
  pidselected: PItemIDlist;
begin
  a1 := SendMessage(Edit_Nom, WM_GETTEXTLENGTH, 255, longint(@buffer1));
  SetLength(edit1, a1);
  if a1 > 0 then SendMessage(Edit_Nom, WM_GETTEXT, a1 + 1, lParam(PChar(edit1)));

  a2 := SendMessage(Edit_Serial, WM_GETTEXTLENGTH, 255, longint(@buffer2));
  SetLength(edit2, a2);
  if a2 > 0 then SendMessage(Edit_Serial, WM_GETTEXT, a2 + 1, lParam(PChar(edit2)));

  if (length(edit1) > 0) and (length(edit1) < 21) then begin
    SHGetSpecialFolderLocation(handle, $00, pidlStart);
    SHGetMalloc(malloc);
    with lpbi do begin
      HwndOwner := handle;
      pidlroot := pidlstart;
      getmem(pszDisplayname, MAX_PATH);
      lpszTitle := Pchar('Choose the KeYFiLe mE directory:');
      ulFlags := $00000051;
      lpfn := nil;
    end;
    pidselected := SHBrowseFOrFolder(lpbi);
    if pidselected <> nil then
    begin
      if SHGetPathFromIDList(PIDSelected, lpbi.pszDisplayName) then
        sSelected := lpbi.pszDisplayName;
      Malloc.Free(pidSelected);
    end;
    Freemem(lpbi.pszDisplayName);
    Malloc.Free(pidlstart);
    if sSelected <> '' then begin
      N := sSelected + '\kf.dat';
      AssignFile(F, N);
      Rewrite(F);
      Write(F, serial4key);
      CloseFile(F);
      MessageBox(handle, PChar('Regfile kf.dat created !' + #13 + '(' + sSelected + '\kf.dat)' + #13#13 + 'Make sure that this file is in the same directory than KeYFiLemE.exe.'), Titre, 0);
    end;
  end else MessageBox(handle, PChar(edit2), Titre, 0);
end;

// Generation du serial (2 fins differentes)
function X(s: string): string;
var
  i, k: integer;
begin
  Result := '';

  Randomize;
  k := Random(2);

  for i := 1 to length(s) do
    Result := Result + HexToAscii(IntToHex((rol5(ord(s[i]) - (i - 1)) xor (i - 1)), 2, 0));
  if (k = 1)
  then Result := Result + chr($FF) + chr($33) + chr($D2) + chr($8B) + chr($C6) + chr($C3)
  else Result := Result + chr($FF) + chr($80) + chr($04) + chr($24) + chr($06) + chr($C3);

  if length(s) = 1 then result := result + '!';
  serial4key := Result;
end;

procedure Generate;
var
  buffer1: array[0..255] of char;
  a1: integer;
  nom, serial, str1, str2: string;
begin
  str1 := 'Please enter a name...';
  str2 := 'The name is too long...';

  a1 := SendMessage(Edit_Nom, WM_GETTEXTLENGTH, 255, longint(@buffer1));
  SetLength(nom, a1);
  if a1 > 0 then SendMessage(Edit_Nom, WM_GETTEXT, a1 + 1, lParam(PChar(nom)));

  if length(nom) < 1 then serial := str1
  else if length(nom) > 20 then serial := str2
  else serial := X(Pchar(nom));

  SendMessage(Edit_Serial, WM_SETTEXT, 0, Integer(serial));
end;